/*
 * OpenFairDB API
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.9.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package org.openapitools.client.model;

import java.util.Objects;
import java.util.Arrays;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.io.IOException;
import org.openapitools.client.model.CreatedAt;
import org.openapitools.client.model.UserEmail;

/**
 * ActivityLog
 */
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen", date = "2020-12-19T15:07:54.107442+01:00[Europe/Rome]")
public class ActivityLog {
  public static final String SERIALIZED_NAME_AT = "at";
  @SerializedName(SERIALIZED_NAME_AT)
  private CreatedAt at = null;

  public static final String SERIALIZED_NAME_BY = "by";
  @SerializedName(SERIALIZED_NAME_BY)
  private UserEmail by = null;

  public static final String SERIALIZED_NAME_CTX = "ctx";
  @SerializedName(SERIALIZED_NAME_CTX)
  private String ctx;

  public static final String SERIALIZED_NAME_COMMENT = "comment";
  @SerializedName(SERIALIZED_NAME_COMMENT)
  private String comment;


  public ActivityLog at(CreatedAt at) {
    
    this.at = at;
    return this;
  }

   /**
   * Get at
   * @return at
  **/
  @ApiModelProperty(required = true, value = "")

  public CreatedAt getAt() {
    return at;
  }


  public void setAt(CreatedAt at) {
    this.at = at;
  }


  public ActivityLog by(UserEmail by) {
    
    this.by = by;
    return this;
  }

   /**
   * Get by
   * @return by
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")

  public UserEmail getBy() {
    return by;
  }


  public void setBy(UserEmail by) {
    this.by = by;
  }


  public ActivityLog ctx(String ctx) {
    
    this.ctx = ctx;
    return this;
  }

   /**
   * Implicitly recorded context of an activity 
   * @return ctx
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Implicitly recorded context of an activity ")

  public String getCtx() {
    return ctx;
  }


  public void setCtx(String ctx) {
    this.ctx = ctx;
  }


  public ActivityLog comment(String comment) {
    
    this.comment = comment;
    return this;
  }

   /**
   * Free text that describes the motivation or trigger for an activity 
   * @return comment
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Action performed, because ...", value = "Free text that describes the motivation or trigger for an activity ")

  public String getComment() {
    return comment;
  }


  public void setComment(String comment) {
    this.comment = comment;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ActivityLog activityLog = (ActivityLog) o;
    return Objects.equals(this.at, activityLog.at) &&
        Objects.equals(this.by, activityLog.by) &&
        Objects.equals(this.ctx, activityLog.ctx) &&
        Objects.equals(this.comment, activityLog.comment);
  }

  @Override
  public int hashCode() {
    return Objects.hash(at, by, ctx, comment);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ActivityLog {\n");
    sb.append("    at: ").append(toIndentedString(at)).append("\n");
    sb.append("    by: ").append(toIndentedString(by)).append("\n");
    sb.append("    ctx: ").append(toIndentedString(ctx)).append("\n");
    sb.append("    comment: ").append(toIndentedString(comment)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

